/**
 * The program(s) herein may be used  freely
 * for personal use only. It may not be sold, 
 * rented, leased, sublicensed  or  modified 
 * without permission of  the  author.  
 * 
 *           www.carlosbcruz.com
 *           
 * This program is provided "AS IS"  without 
 * warranty of any kind. In no event I  will
 * be liable  for  any  direct  or  indirect 
 * damage.
 */

package com.carlosbcruz.access.model;

import java.util.ArrayList;

/**
 *
 * Store complex parameter
 *
 * @author Carlos Fernando Bella Cruz - <a href="mailto:pessoal@carlosbcruz.com">pessoal@carlosbcruz.com</a>
 */
public class ComplexParameter {

	public static int TABLE_TYPE = 1;
	
	public static int STRUCTURE_TYPE = 2;
	
	private int type = 0;
	
	private String name = null;
	
	private ArrayList parameters = new ArrayList();
	
	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}
	
	/**
	 * @return Returns the parameters.
	 */
	public SimpleParameter getParameters(int i) {
		return (SimpleParameter) parameters.get(i);
	}
	
	/**
	 * @param parameters The parameters to set.
	 */
	public void addParameters(SimpleParameter parameter) {
		this.parameters.add(parameter);
	}
	
	/**
	 * @return the number of available parameters
	 */
	public int getNumberOfParameters() {
		return this.parameters.size();
	}
	
	/**
	 * @return Returns the type.
	 */
	public int getType() {
		return type;
	}
	
	/**
	 * @param type The type to set.
	 */
	public void setType(int type) {
		this.type = type;
	}
}
