/**
 * The program(s) herein may be used  freely
 * for personal use only. It may not be sold, 
 * rented, leased, sublicensed  or  modified 
 * without permission of  the  author.  
 * 
 *           www.carlosbcruz.com
 *           
 * This program is provided "AS IS"  without 
 * warranty of any kind. In no event I  will
 * be liable  for  any  direct  or  indirect 
 * damage.
 */

package com.carlosbcruz.sapproxy.generator;

import java.util.Properties;

import com.sap.conn.jco.ext.DestinationDataEventListener;
import com.sap.conn.jco.ext.DestinationDataProvider;
import com.sap.conn.jco.ext.Environment;

/**
 * Provides the information to the SAP destination.
 *  
 * @author Carlos Fernando Bella Cruz - <a href="mailto:pessoal@carlosbcruz.com">pessoal@carlosbcruz.com</a>
 */
public class SystemDestinationDataProvider implements DestinationDataProvider {

	private static String host = new String();
	private static String systemName = new String();
	private static String client = new String();
	private static String group = new String();
	private static String user = new String();
	private static String password = new String();

	/**
	 * Set the host name.
	 * 
	 * @param host
	 *            The host name.
	 */
	public static void setHost(String host) {
		SystemDestinationDataProvider.host = host;
	}

	/**
	 * Set the system name.
	 * 
	 * @param systemName
	 *            The system name.
	 */
	public static void setSystemName(String systemName) {
		SystemDestinationDataProvider.systemName = systemName;
	}

	/**
	 * Set the client number.
	 * 
	 * @param client
	 *            The client number.
	 */
	public static void setClient(String client) {
		SystemDestinationDataProvider.client = client;
	}

	/**
	 * Set the group name.
	 * 
	 * @param group
	 *            The group name.
	 */
	public static void setGroup(String group) {
		SystemDestinationDataProvider.group = group;
	}

	/**
	 * Set the user identification.
	 * 
	 * @param user
	 *            The user identification.
	 */
	public static void setUser(String user) {
		SystemDestinationDataProvider.user = user;
	}

	/**
	 * Set the password.
	 * 
	 * @param password
	 *            The password.
	 */
	public static void setPassword(String password) {
		SystemDestinationDataProvider.password = password;
	}

	//@Override
	public Properties getDestinationProperties(String arg0) {

		Properties connectionProperties = new Properties();

		connectionProperties.setProperty(DestinationDataProvider.JCO_MSHOST,
				host);
		connectionProperties.setProperty(DestinationDataProvider.JCO_R3NAME,
				systemName);
		connectionProperties.setProperty(DestinationDataProvider.JCO_CLIENT,
				client);
		connectionProperties.setProperty(DestinationDataProvider.JCO_GROUP,
				group);
		connectionProperties
				.setProperty(DestinationDataProvider.JCO_USER, user);
		connectionProperties.setProperty(DestinationDataProvider.JCO_PASSWD,
				password);
		connectionProperties
				.setProperty(DestinationDataProvider.JCO_LANG, "en");

		return connectionProperties;
	}

	//@Override
	public void setDestinationDataEventListener(
			DestinationDataEventListener arg0) {

		// Do nothing.
	}

	//@Override
	public boolean supportsEvents() {

		return false;
	}

	/**
	 * Request that this destination data provide self register in the
	 * enviroment.
	 */
	public static void selfRegister() {
		Environment
				.registerDestinationDataProvider(new SystemDestinationDataProvider());
	}
}
