/**
 * Maintenance:
 * 
 * 2010-Jul-08      Carlos F.Bella Cruz     Creation.
 */
package com.carlosbcruz.sapproxy.generator.model;

import java.io.Serializable;
import java.util.ArrayList;

/**
 * Store complex parameter
 */
public class ComplexParameter implements Serializable {

	/**
	 * Serial
	 */
	private static final long serialVersionUID = 1L;

	public static int TABLE_TYPE = 1;

	public static int STRUCTURE_TYPE = 2;

	private int type = 0;

	private int position = 0;

	private String name = null;

	private String structureName = null;

	private ArrayList<SimpleParameter> parameters = new ArrayList<SimpleParameter>();

	/**
	 * Inform the set of parameters.
	 * 
	 * @return the set of parameters.
	 */
	public ArrayList<SimpleParameter> getParameters() {
		return parameters;
	}

	/**
	 * Set the parameters.
	 * 
	 * @param parameters
	 *            The parameters.
	 */
	public void setParameters(ArrayList<SimpleParameter> parameters) {
		this.parameters = parameters;
	}

	/**
	 * @return Returns the name.
	 */
	public String getName() {
		return name;
	}

	/**
	 * @param name
	 *            The name to set.
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * @return the structure name
	 */
	public String getStructureName() {
		return structureName;
	}

	/**
	 * @param structureName
	 *            the structure name
	 */
	public void setStructureName(String structureName) {
		this.structureName = structureName;
	}

	/**
	 * @return Returns the parameters.
	 */
	public SimpleParameter getParameters(int i) {
		return (SimpleParameter) parameters.get(i);
	}

	/**
	 * @param parameters
	 *            The parameters to set.
	 */
	public void addParameters(SimpleParameter parameter) {
		this.parameters.add(parameter);
	}

	/**
	 * @return the number of available parameters
	 */
	public int getNumberOfParameters() {
		return this.parameters.size();
	}

	/**
	 * @return Returns the type.
	 */
	public int getType() {
		return type;
	}

	/**
	 * @param type
	 *            The type to set.
	 */
	public void setType(int type) {
		this.type = type;
	}

	/**
	 * @return The position.
	 */
	public int getPosition() {
		return position;
	}

	/**
	 * @param position
	 *            The position.
	 */
	public void setPosition(int position) {
		this.position = position;
	}
}
